'\" t
.\" Copyright 1999 Oracle and/or its affiliates. All rights reserved.
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining a
.\" copy of this software and associated documentation files (the "Software"),
.\" to deal in the Software without restriction, including without limitation
.\" the rights to use, copy, modify, merge, publish, distribute, sublicense,
.\" and/or sell copies of the Software, and to permit persons to whom the
.\" Software is furnished to do so, subject to the following conditions:
.\"
.\" The above copyright notice and this permission notice (including the next
.\" paragraph) shall be included in all copies or substantial portions of the
.\" Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
.\" IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
.\" FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
.\" THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
.\" LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
.\" FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
.\" DEALINGS IN THE SOFTWARE.
.\"
.TH XkbSetModActionVMods __libmansuffix__ __xorgversion__ "XKB FUNCTIONS"
.SH NAME
XkbSetModActionVMods \- Sets the vmods1 and vmods2 fields of act using the vmods 
format of an Xkb modifier description
.SH SYNOPSIS
.HP
.B void XkbSetModActionVMods
.BI "(\^XkbAction " "act" "\^,"
.BI "unsigned short " "vmods" "\^);"
.if n .ti +5n
.if t .ti +.5i
.SH ARGUMENTS
.TP
.I \- act
action in which to set vmods
.TP
.I \- vmods
virtual mods to set
.SH DESCRIPTION
.LP
.I XkbSetModActionVMods 
sets the 
.I vmods1 
and 
.I vmods2 
fields of 
.I act 
using the 
.I vmods 
format of an Xkb modifier description. 
.SH NOTES
.LP
Despite the fact that the first parameter of these two macros is of type 
XkbAction, these macros may be used only with Actions of type XkbModAction and 
XkbISOAction.
